# Inverzní matice, Gaussova-Jordanova eliminační metoda
## Inverzní matice
- X je inverzní k A, jestliže platí $A * X = X * A = I$
- inverzní matice $A^{-1}$ nemusí pro matici $A$ vždy existovat. Pokud ale existuje, je jednoznačně určená.
    - $A \cdot A^{-1} = A^{-1} \cdot A = I$
    - $(AB)^{-1} = A^{-1}B^{-1}$

- inverzní matice $A^{-1}$ k matici $A$ existuje pouze, pokud je matice $A$ regulární.
- inverzní matice k matici $A$ existuje maximálně jedna

### Adjungovaná matice

Adjungovaná matice je matice $A^A$, která je poskládaná z algebraických doplňků, ale **transponovaně**.

#### Určení inverzní matice pomocí determinantů

Pokud je matice A regulární, je možné získat inverzní matici.

$\displaystyle A^{-1} = \frac{1}{\det(A)} \cdot A^A$

![[_assets/inverzni-matice-determinant.jpg]]

## Gaussova-Jordanova eliminační metoda
- vylepšená GEM metoda
- nejdříve provedeme GEM metodu (převede matici do stupňovitého tvaru)
- potom ve sloupcích, kde se nachází pivotní prvky vynulujeme prvky nad pivotama
- pro jednodušší vyčtení výsledku soustavy rovnic